#include "metatask.h"
#include <Handle.h>
#include <f90cxx.h>
#include <stringutil.h>
#include <cstdio>
#include <cstring>

F90PROCDEF(void,task)(Routine t)
{
  task(t);
}

F90PROCDEF(Handle<Info::Task>,gettaskinfo)
  (const char * name,int nameLength)
{
  Info::Task* t=0;
  if (name) {
    string n=trim(string(name,nameLength));
    t=task(n.c_str());
  }
  else  t=Info::Task::current();

  return t;
}

F90PROCDEF(void,taskinfoname)
  (char * name,int nameLength,const Handle<Info::Task > & h)
{
  string n =trim(string(name,nameLength));

  Info::Task* t=h.addressOfObject();
  //sprintf(name,"%-*.*s",nameLength,nameLength,t->name());

  // AI: Notice that F90 is asking for 256 char len and the index  
  // in C++ starts in 0, while in F90 starts in 1... So therefore, we have to pass
  // to F90 255 char len... Or we have to do what it's written below..
  const int len = min( int(strlen(t->name()) ), nameLength );
  memcpy( name, t->name(), len );
  memset( name + len, ' ', nameLength - len );

}

F90PROCDEF(void,taskinfoversion)
  (char * name,int nameLength,const Handle<Info::Task>& h)
{
  Info::Task* t=h.addressOfObject();
  //sprintf(name,"%-*.*s",nameLength,nameLength,t->version());

  const int len = min( int(strlen(t->name()) ), nameLength );
  memcpy( name, t->name(), len );
  memset( name + len, ' ', nameLength - len );

}

F90PROCDEF(void,taskinfopackage)
  (char * name,int nameLength,const Handle<Info::Task>& h)
{
  Info::Task* t=h.addressOfObject();
  //sprintf(name,"%-*.*s",nameLength,nameLength,t->package());
  
  const int len = min( int(strlen(t->name()) ), nameLength );
  memcpy( name, t->name(), len );
  memset( name + len, ' ', nameLength - len );


}

F90PROCDEF(void,taskinforelease)
  (char * name,int nameLength,const Handle<Info::Task>& h)
{
  Info::Task* t=h.addressOfObject();
  //sprintf(name,"%-*.*s",nameLength,nameLength,t->release());
  
  const int len = min( int(strlen(t->name()) ), nameLength );
  memcpy( name, t->name(), len );
  memset( name + len, ' ', nameLength - len );


}
