// -*-C++-*-
#include "testtasklib.h"

void testtasklib::test(const char* nm)
{
  errstr << "testtasklib::test("
	 << nm << ") START"
	 << Sas::message(Msg::Lib,Msg::Always);

  if (!gParameters) {
    errstr << "No gParameters while visiting task("
	   << nm << ")"
	   << Sas::error("corruptedInvocation");
    
  }

  Info::Task* t= Info::Task::current();
  if (!t) {
    errstr << "Info::Task::current() while visiting task("
	   << nm << ")"
	   << Sas::error("corruptedInvocation");
  }
  
  if (std::string(nm) != t->name()) {
    errstr << "Info::Task::current("
	   << t->name() << ") != (" << nm<< ")"
	   << Sas::error("corruptedInvocation");
  }

  if (gParameters != t->parameters()) {
    errstr << "gParameters->taskName()=" << gParameters->taskName()
	   << " != t->parameters()->taskName()=" << t->parameters()->taskName()
	   << Sas::error("corruptedInvocation");
  }

  errstr << "testtasklib::test("
	 << nm << ") END"
	 << Sas::message(Msg::Lib,Msg::Always);
}
